%Methodology Template {#MethodologyTemplate}
==========================

Overview
========

Abstract
--------

Brief summary of what.

In general, write the abstract as one sentence from each major section.
So, one intro, one methods, one validation/results, and one conclusions.

Introduction
------------

More details about why and how.

System Design
=============

Background and Scope
--------------------

Include where the models originated and why we chose them.

### Requirements

### Existing

### Approach

Data Flow
---------

### Initialize

Initialize, setup, tune, conditions, stabilization, etc.

### Preprocess

### Process

### Post Process

### Assessments

Features and Capabilities
-------------------------

Include a discussion about model fidelity.

### Definitions

Table with symbols (if needed).

### Circuit

Include a circuit diagram.

### Patient Variability

How changes in the patient affect the model.

### Feedback

How the homeostatic methodology works.

### Dependencies

How does this system interact with other systems?

### Outputs

Any discussion about system outputs?

Assumptions and Limitations
---------------------------

Conditions
----------

Actions
-------

### Insults

### Interventions

Events
------

Include irreversible states.

Assessments
-----------

Results and Conclusions
=======================

%Verification
-------------

Often through unit tests.

Validation - Resting Physiologic State
--------------------------------------

Use the auto-generated table.

Explain the good and the bad, note why the bad is either being addressed
or okay.

Validation - Conditions
-----------------------

Include validation tables.

Validation - Actions
--------------------

Include validation tables and plots.

Validation - Assessments
------------------------

Conclusions
-----------

1-2 sentences for each of the following: sum up what we have done, have
we advanced the state of the art (hint: yes), note the worst and how it
is being addressed or why it is ok, note the best stuff, why is this is
good step, who will find this useful

Future Work
===========

Coming Soon
-----------

What else is in the works.

Improvements to existing methodology planned. Include
a why statement. Need to know why this improvement is a good thing to
do, what is gained.

Recommended Improvements
------------------------

What should be updated and why.

Appendices
==========

Acronyms
--------

Define terms and acronyms.

Data Model Implementation
-------------------------

Link to associated classes.

Compartments
------------

Include a tree showing the compartments.